//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class XmlSerializer : global::System.IDisposable {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;
  protected bool swigCMemOwn;

  internal XmlSerializer(global::System.IntPtr cPtr, bool cMemoryOwn) {
    swigCMemOwn = cMemoryOwn;
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(XmlSerializer obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~XmlSerializer() {
    Dispose();
  }

  public virtual void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_XmlSerializer(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
    }
  }

  public static string serializeSystem(System arg0) {
    string ret = OpenMMSwigPINVOKE.XmlSerializer_serializeSystem(System.getCPtr(arg0));
    return ret;
  }

  public static System deserializeSystem(string inputString) {
    global::System.IntPtr cPtr = OpenMMSwigPINVOKE.XmlSerializer_deserializeSystem(inputString);
    System ret = (cPtr == global::System.IntPtr.Zero) ? null : new System(cPtr, true);
    return ret;
  }

  public static string _serializeForce(Force arg0) {
    string ret = OpenMMSwigPINVOKE.XmlSerializer__serializeForce(Force.getCPtr(arg0));
    return ret;
  }

  public static Force _deserializeForce(string inputString) {
    global::System.IntPtr cPtr = OpenMMSwigPINVOKE.XmlSerializer__deserializeForce(inputString);
    Force ret = (cPtr == global::System.IntPtr.Zero) ? null : new Force(cPtr, true);
    return ret;
  }

  public static string _serializeIntegrator(Integrator arg0) {
    string ret = OpenMMSwigPINVOKE.XmlSerializer__serializeIntegrator(Integrator.getCPtr(arg0));
    return ret;
  }

  public static Integrator _deserializeIntegrator(string inputString) {
    global::System.IntPtr cPtr = OpenMMSwigPINVOKE.XmlSerializer__deserializeIntegrator(inputString);
    Integrator ret = (cPtr == global::System.IntPtr.Zero) ? null : new Integrator(cPtr, true);
    return ret;
  }

  public XmlSerializer() : this(OpenMMSwigPINVOKE.new_XmlSerializer(), true) {
  }

}

}
